/*
 * bpfx.e.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <bpfx-defs.h>
#include <bpfx-inter.h>
#include <bpfx-names.h>

#define bpfset(bpfset)			((struct bpfset_type *) (bpfset))

int
x1f4_flat_bpfset(void *bpfset)
{
    int status;

    status = _libx1f4l2_ceil_bpfset(bpfset);
    if (status) {
    } else {
	status = bpfset(bpfset)->link_m.free
	    (bpfset(bpfset)->link_m.data, bpfset(bpfset)->link_a.fpnews.node);
	if (status) {
	    status = FREE_ERROR;
	}
    }

    return status;
}
