/*
 * dfxy.5.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <stddef.h>

#include <dfxx-defs.h>
#include <dfxx-names.h>
#include <dfxx-types.h>
#include <mask.0.h>
#include <trans.h>

#define dflist(dflist)			((struct dflist_type *) (dflist))

int
x1f4_fast_dflist(void *dflist, unsigned flags,
		 struct screen_type *screen_data)
{
    if (0) {
    } else {
	dflist(dflist)->link_a.fplist.fplink.fpnode_data[0] = NULL;
	dflist(dflist)->link_a.fplist.fplink.fpnode_data[1] = NULL;

	dflist(dflist)->link_a.fplist.link_v.size = 0;

	if (flags & TRANS_MASK) {
	    struct trans_type *trans_data;

	    trans_data = screen_data->trans_data;

	    dflist(dflist)->link_m.data = trans_data->data;
	    dflist(dflist)->link_m.free = trans_data->free;
	    dflist(dflist)->link_m.link = trans_data->link;
	    dflist(dflist)->link_m.mode = trans_data->mode;
	} else {
	    dflist(dflist)->link_m.free = _libx1f4l2_free_data;
	    dflist(dflist)->link_m.link = _libx1f4l2_link_data;
	    dflist(dflist)->link_m.mode = _libx1f4l2_mode_data;
	}
    }

    return 0;
}
