/*
 * l4xx.n.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <l4xx-types.h>

#define l4list(l4list)			((struct l4list_type *) (l4list))

#define list64(list64)			((struct list64_type *) (list64))

int
_libx1f4l2_tfix_l4list(void *l4list, int stride_is_count, void *list64)
{
    struct list64_type *tail64_list;

    tail64_list = l4list(l4list)->link_a.list88.tail64_data;

    list64(list64)->last_1 = tail64_list;
    list64(list64)->next_1 = NULL;

    tail64_list->next_1 = list64(list64);

    l4list(l4list)->link_a.list88.tail64_data = list64(list64);

    if (0) {
    }

    if (0) {
    } else {
	list64(list64)->next_7 = NULL;

	if (stride_is_count) {
	    struct list64_type *head64_list;

	    head64_list = l4list(l4list)->link_a.list88.head64_data;

	    head64_list->next_7 = list64(list64);
	    list64(list64)->last_0 = head64_list;
	} else {
	    tail64_list = tail64_list->last_0;
	    tail64_list = tail64_list->next_1;
	    list64(list64)->last_0 = tail64_list;
	    tail64_list->next_7 = list64(list64);
	}
    }

    return 0;
}
