/*
 * l4xx.r.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <l4xx-types.h>

#define false(e)			0

#define l4list(l4list)			((struct l4list_type *) (l4list))

#define list64(list64)			((struct list64_type *) (list64))

int
_libx1f4l2_fast_l4list(void *l4list, unsigned index, void *list64)
{
    if (0) {
    } else {
	struct list64_type *head64_list, *tail64_list;
	unsigned count, stride;

	count = l4list(l4list)->link_a.list88.count;

	if (1) {
	    unsigned class;

	    class = l4list(l4list)->link_c.class;

	    if (false(index ^ class)) {
		if (index < class) {
		    l4list(l4list)->link_c.class = class - 1;
		}
	    } else {
		if (index + 1 < count) {
		    l4list(l4list)->link_c.list64_data =
			list64(list64)->next_1;
		} else {
		    l4list(l4list)->link_c.class = class - 1;
		    l4list(l4list)->link_c.list64_data =
			list64(list64)->last_0;
		}
	    }
	}

	stride = l4list(l4list)->link_a.list88.stride;

	head64_list = l4list(l4list)->link_a.list88.head64_data;
	tail64_list = l4list(l4list)->link_a.list88.tail64_data;

	count--;

	if (list64 == head64_list) {
	    head64_list = list64(list64)->next_1;
	    head64_list->last_1 = NULL;

	    l4list(l4list)->link_a.list88.head64_data = head64_list;

	    if (count < stride) {
	    } else {
		struct list64_type *swap64_list;

		swap64_list = list64(list64)->next_7;
		if (swap64_list) {
		    swap64_list->last_0 = NULL;
		}
	    }
	} else {
	    if (list64 == tail64_list) {
		tail64_list = list64(list64)->last_1;
		tail64_list->next_1 = NULL;

		l4list(l4list)->link_a.list88.tail64_data = tail64_list;

		if (count < stride) {
		} else {
		    struct list64_type *swap64_list;

		    swap64_list = list64(list64)->last_0;
		    if (swap64_list) {
			swap64_list->next_7 = NULL;
		    }
		}
	    } else {
		struct list64_type *last64_list, *next64_list;

		last64_list = list64(list64)->last_1;
		next64_list = list64(list64)->next_1;

		last64_list->next_1 = next64_list;
		next64_list->last_1 = last64_list;

		if (count < stride) {
		} else {
		    struct list64_type *post64_list, *swap64_list;

		    post64_list = list64(list64)->last_0;
		    if (post64_list) {
		    } else {
			post64_list = head64_list;
		    }

		    swap64_list = post64_list->next_7;

		    for (;;) {
			swap64_list = swap64_list->next_1;
			post64_list->next_7 = swap64_list;
			if (!swap64_list) {
			    break;
			} else {
			    post64_list = post64_list->next_1;
			    if (post64_list == next64_list) {
				break;
			    }
			}
		    }

		    post64_list = list64(list64)->next_7;
		    if (post64_list) {
		    } else {
			post64_list = tail64_list;
		    }

		    swap64_list = post64_list->last_0;

		    for (;;) {
			swap64_list = swap64_list->last_1;
			post64_list->last_0 = swap64_list;
			if (!swap64_list) {
			    break;
			} else {
			    post64_list = post64_list->last_1;
			    if (post64_list == last64_list) {
				break;
			    }
			}
		    }
		}
	    }
	}
    }

    return 0;
}
