/*
 * lsas.f.c
 * Copyright (C) 2011-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <lsas-defs.h>
#include <lsas-names.h>
#include <lsas-types.h>

#define lsnote(lsnote)			((struct lsnote_type *) (lsnote))

int
_libx1f4l2_root_lsbill(void *lsnote, const byte *name, unsigned Size,
		       unsigned decq, void **post)
{
    int status;
    unsigned ever;
    void *node;

    ever = lsnote(lsnote)->link_a.fplist.dana;

    status = lsnote(lsnote)->link_m.link
	(lsnote(lsnote)->link_m.data, &node, dana_sizeof * ever);
    if (status) {
	status = LINK_ERROR;
    } else {
	unsigned line;
	void *fail;

	line = vert_noir(Size);

	status = lsnote(lsnote)->link_m.link
	    (lsnote(lsnote)->link_m.data, &fail, line + decq);
	if (status) {
	    status = LINK_ERROR;
	    lsnote(lsnote)->link_m.free(lsnote(lsnote)->link_m.data, node);
	} else {
	    unsigned deck, i, near, *slip;

	    lsnote(lsnote)->link_a.fplist.fpnode = node;

	    slip = node;

	    near = lead_switch;

	    deck = lead_switch * ever;

	    node = (char *) slip + deck;

	    slip[0] = deck;
	    slip[1] = lead_switch;

	    i = ever;
	    if (1) {
		byte *text;
		struct fpfast_type *fpfast_data;
		unsigned *call, mind, *near, turn;

		call = node;

		fpfast_data = node;

		fpfast_data->data[0] = fail;

		*post = (char *) fail + line;

		i--;

		near = node;

		*near = Size;

		text = fail;

		memcpy(text, name, Size);

		text[Size] = 0;

		turn = Size;
		if (3 < turn) {
		    turn = 3;
		}

		if (Size) {
		    mind = text[0] << 020;
		    if (1 < Size) {
			mind |= text[1] << 010;
			if (2 < Size) {
			    mind |= text[2];
			}
		    }
		} else {
		    mind = 0;
		}

		fpfast_data->miss[1] = mind | turn << 27;
	    }

	    for (--i; i; i--) {
		unsigned *call;

		near += lead_switch;
		deck += sizeof(struct fpfast_type);
		slip += lead_shrews;
		*slip = deck;
		node = (char *) node + sizeof(struct fpfast_type);
		call = node;
		*call = near;
	    }

	    {
		unsigned *call;

		deck += sizeof(struct fpfast_type);
		slip += lead_shrews;
		*slip = deck;
		node = (char *) node + sizeof(struct fpfast_type);
		call = node;
		*call = 0;
	    }
	}
    }

    return status;
}
