/*
 * lsas-class.h
 * Copyright (C) 2011-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lsas_class_H__
#define __LIBx1f4_lsas_class_H__

#define class_fast(___B) \
    {									      \
	*post = (char *) (___B) + vert_noir(*near);			      \
	if (1) {							      \
	    break;							      \
	}								      \
    }

#define class_fill(___h, ___f, ___l, ___s) \
    {									      \
	unsigned ___p, ___t;						      \
									      \
	___p = (___h);							      \
									      \
	___t = (___p << 3) - (___l);					      \
	if (24 < ___t) {						      \
	    ___t = 24;							      \
	}								      \
									      \
	if ((___f) >> 24 ^ ___t) {					      \
	    const byte *___w;						      \
	    unsigned ___b, ___e = 0, ___i, ___n;			      \
									      \
	    ___b = (___l) >> 3;						      \
									      \
	    ___w = (___s);						      \
	    ___w += ___b;						      \
									      \
	    ___b = ___p - ___b;						      \
									      \
	    ___i = (___l) & 7;						      \
									      \
	    if (___i) {							      \
		if (4 < ___b) {						      \
		    ___b = 4;						      \
		}							      \
	    } else {							      \
		if (3 < ___b) {						      \
		    ___b = 3;						      \
		}							      \
	    }								      \
									      \
	    ___n = ___b;						      \
									      \
	    while (___b) {						      \
		___b--;							      \
		___e <<= 8;						      \
		___e |= *___w++;					      \
	    }								      \
									      \
	    if (___i) {							      \
		___e <<= ___i;						      \
		___e <<= (4 - ___n) << 3;				      \
		___e >>= 8;						      \
	    } else {							      \
		___e <<= (3 - ___n) << 3;				      \
	    }								      \
									      \
	    (___f) = ___e | ___t << 24;					      \
	}								      \
    }

#define class_find(___n, ___c, ___x) \
    {									      \
	if ((___c)) {							      \
	    const byte *___w;						      \
	    unsigned ___b, ___f;					      \
									      \
	    ___f = 0;							      \
									      \
	    ___w = (___n);						      \
									      \
	    ___b = (___c) >> 3;						      \
	    if ((___c) & 7) {						      \
		___b++;							      \
		if (___b < 6) {						      \
		} else {						      \
		    ___w += ___b;					      \
		    ___w -= 5;						      \
		    ___b = 5;						      \
		}							      \
									      \
		___b--;							      \
									      \
		while (___b) {						      \
		    ___b--;						      \
		    ___f <<= 8;						      \
		    ___f |= *___w++;					      \
		}							      \
									      \
		___f <<= (___c) & 7;					      \
		___f |= *___w >> (8 - ((___c) & 7));			      \
	    } else {							      \
		if (___b < 5) {						      \
		} else {						      \
		    ___w += ___b;					      \
		    ___w -= 4;						      \
		    ___b = 4;						      \
		}							      \
									      \
		while (___b) {						      \
		    ___b--;						      \
		    ___f <<= 8;						      \
		    ___f |= *___w++;					      \
		}							      \
	    }								      \
									      \
	    (___x)[2] = ___f;						      \
	} else {							      \
	    (___x)[2] = 0;						      \
	}								      \
    }

#define class_line(___B) \
    {									      \
	break;								      \
    }

#define class_main(___s, ___n, ___u, ___v, ___c, ___w, ___1) \
    {									      \
	const byte *___a, *___b;					      \
	unsigned ___f, ___x;						      \
									      \
	___x = (___u);							      \
									      \
	___b = (___v);							      \
									      \
	___a = ___b;							      \
									      \
	(___c) = (___s) < ___x ? (___s) : ___x;				      \
	if (SIZEOF_LONG & (SIZEOF_LONG - 1)) {				      \
	} else {							      \
	    if (((integral_q) ___a | (integral_q) (___n))		      \
		& (SIZEOF_LONG - 1)) {					      \
	    } else {							      \
		unsigned ___t;						      \
									      \
		___t = (___c);						      \
		scale(___t);						      \
		if (___t) {						      \
		    for (; ___t; ___t--) {				      \
			if (*(const long *) ___a ^ *(const long *) (___n)) {  \
			    break;					      \
			}						      \
									      \
			___a = (const void *) ((const long *) ___a + 1);      \
			(___n) = (const void *) ((const long *) (___n) + 1);  \
		    }							      \
									      \
		    (___c) -= ___a - ___b;				      \
		}							      \
	    }								      \
	}								      \
	for (; (___c); (___c)--) {					      \
	    ___f = *___a ^ *((unsigned char *) (___n));			      \
	    if (___f) {							      \
		if (1) {						      \
		    break;						      \
		}							      \
	    }								      \
									      \
	    ___a++;							      \
	    (___n)++;							      \
	}								      \
									      \
	if ((___c)) {							      \
	    if ((___s) < ___x) {					      \
		(___c) = (___s) - (___c);				      \
	    } else {							      \
		(___c) = ___x - (___c);					      \
	    }								      \
									      \
	    (___c) <<= 3;						      \
	    if (___f & 240) {						      \
	    } else {							      \
		(___c) += 4;						      \
		___f <<= 4;						      \
	    }								      \
	    if (___f & 192) {						      \
	    } else {							      \
		(___c) += 2;						      \
		___f <<= 2;						      \
	    }								      \
	    if (___f & 128) {						      \
	    } else {							      \
		(___c)++;						      \
	    }								      \
									      \
	    (___w) = *___a << ((___c) & 7) >> 7 & 1;			      \
	} else {							      \
	    if ((___s) ^ ___x) {					      \
		Monday = 1;						      \
		if ((___s) < ___x) {					      \
		    (___c) = (___s) << 3;				      \
		    (___w) = 1;						      \
		} else {						      \
		    (___c) = ___x << 3;					      \
		    (___w) = 0;						      \
		}							      \
	    } else {							      \
		status = (___1);					      \
		if (1) {						      \
		    break;						      \
		}							      \
	    }								      \
	}								      \
									      \
	(___n) -= (___c) >> 3;						      \
    }

#undef class_main

#define class_main(___s, ___n, ___u, ___v, ___c, ___w, ___1) \
    {									      \
	const byte *___a, *___b;					      \
	unsigned ___f, ___x;						      \
									      \
	___x = (___u);							      \
									      \
	___b = (___v);							      \
									      \
	___a = ___b;							      \
									      \
	(___c) = (___s) < ___x ? (___s) : ___x;				      \
	for (; (___c); (___c)--) {					      \
	    ___f = *___a ^ *((unsigned char *) (___n));			      \
	    if (___f) {							      \
		if (1) {						      \
		    break;						      \
		}							      \
	    }								      \
									      \
	    ___a++;							      \
	    (___n)++;							      \
	}								      \
									      \
	if ((___c)) {							      \
	    if ((___s) < ___x) {					      \
		(___c) = (___s) - (___c);				      \
	    } else {							      \
		(___c) = ___x - (___c);					      \
	    }								      \
									      \
	    (___c) <<= 3;						      \
	    if (___f & 240) {						      \
	    } else {							      \
		(___c) += 4;						      \
		___f <<= 4;						      \
	    }								      \
	    if (___f & 192) {						      \
	    } else {							      \
		(___c) += 2;						      \
		___f <<= 2;						      \
	    }								      \
	    if (___f & 128) {						      \
	    } else {							      \
		(___c)++;						      \
	    }								      \
									      \
	    (___w) = *___a << ((___c) & 7) >> 7 & 1;			      \
	} else {							      \
	    if ((___s) ^ ___x) {					      \
		Monday = 1;						      \
		if ((___s) < ___x) {					      \
		    (___c) = (___s) << 3;				      \
		    (___w) = 1;						      \
		} else {						      \
		    (___c) = ___x << 3;					      \
		    (___w) = 0;						      \
		}							      \
	    } else {							      \
		status = (___1);					      \
		if (1) {						      \
		    break;						      \
		}							      \
	    }								      \
	}								      \
									      \
	(___n) -= (___c) >> 3;						      \
    }

#define class_miss(___s, ___n, ___u, ___v, ___o, ___c, ___w, ___1, ___2) \
    {									      \
	const byte *___a, *___b;					      \
	unsigned ___f, ___x;						      \
									      \
	___x = (___u);							      \
									      \
	___b = (___v);							      \
									      \
	___a = ___b;							      \
									      \
	(___c) = (___s) < ___x ? (___s) : ___x;				      \
									      \
	___f = (___o);							      \
									      \
	___a += ___f;							      \
	(___c) -= ___f;							      \
	(___n) += ___f;							      \
									      \
	for (; (___c); (___c)--) {					      \
	    ___f = *___a ^ *((unsigned char *) (___n));			      \
	    if (___f) {							      \
		if (1) {						      \
		    break;						      \
		}							      \
	    }								      \
									      \
	    ___a++;							      \
	    (___n)++;							      \
	}								      \
									      \
	if ((___c)) {							      \
	    if ((___s) < ___x) {					      \
		(___c) = (___s) - (___c);				      \
	    } else {							      \
		(___c) = ___x - (___c);					      \
	    }								      \
									      \
	    (___c) <<= 3;						      \
	    if (___f & 240) {						      \
	    } else {							      \
		(___c) += 4;						      \
		___f <<= 4;						      \
	    }								      \
	    if (___f & 192) {						      \
	    } else {							      \
		(___c) += 2;						      \
		___f <<= 2;						      \
	    }								      \
	    if (___f & 128) {						      \
	    } else {							      \
		(___c)++;						      \
	    }								      \
									      \
	    (___w) = *___a << ((___c) & 7) >> 7 & 1;			      \
	} else {							      \
	    if ((___s) ^ ___x) {					      \
		Monday = 1;						      \
		if ((___s) < ___x) {					      \
		    (___c) = (___s) << 3;				      \
		    (___w) = 1;						      \
		} else {						      \
		    (___c) = ___x << 3;					      \
		    (___w) = 0;						      \
		}							      \
	    } else {							      \
		status = (___1);					      \
		if (1) {						      \
		    ___2(___b);						      \
		}							      \
	    }								      \
	}								      \
									      \
	(___n) -= (___c) >> 3;						      \
    }

#define class_nine(___n, ___s, ___i, ___x) \
    {									      \
	const byte *___w;						      \
	unsigned ___b, ___e = 0, ___f, ___q, ___t;			      \
									      \
	___t = ((___s) << 3) - (___i);					      \
	if (24 < ___t) {						      \
	    ___t = 24;							      \
	}								      \
									      \
	___b = (___i) >> 3;						      \
									      \
	___w = (___n) + ___b;						      \
									      \
	___b = (___s) - ___b;						      \
									      \
	___f = (___i) & 7;						      \
									      \
	if (___f) {							      \
	    if (4 < ___b) {						      \
		___b = 4;						      \
	    }								      \
	} else {							      \
	    if (3 < ___b) {						      \
		___b = 3;						      \
	    }								      \
	}								      \
									      \
	___q = ___b;							      \
									      \
	while (___b) {							      \
	    ___b--;							      \
	    ___e <<= 8;							      \
	    ___e |= *___w++;						      \
	}								      \
									      \
	if (___f) {							      \
	    ___e <<= ___f;						      \
	    ___e <<= (4 - ___q) << 3;					      \
	    ___e >>= 8;							      \
	} else {							      \
	    ___e <<= (3 - ___q) << 3;					      \
	}								      \
									      \
	(___x)[1] = ___e | ___t << 24;					      \
    }

#define class_pick(___n, ___x) \
    ((___n)[(___x) >> 3] >> (7 - ((___x) & 7)) & 1)

#define class_rail(___o, ___d, ___l) \
    {									      \
	unsigned ___c, *___n;						      \
									      \
	___n = (void *) ((char *) (___o) + (___d));			      \
	___c = *___n;							      \
	if (___c & POINT_CAST) {					      \
	} else {							      \
	    unsigned ___e, ___f, ___h;					      \
									      \
	    ___f = ___n[1];						      \
	    ___h = ___f & ((1 << 24) - 1);				      \
	    ___f >>= 24;						      \
	    ___e = (___l);						      \
	    if (___e < ___f) {						      \
		___n[1] =						      \
		    (___h << ___e & ((1 << 24) - 1)) | (___f - ___e) << 24;   \
	    } else {							      \
		if (___f) {						      \
		    ___n[1] = 0;					      \
		}							      \
	    }								      \
	}								      \
    }

#define class_ware(___s, ___n, ___u, ___v, ___c, ___w) \
    {									      \
	const byte *___a, *___b;					      \
	unsigned ___f, ___x;						      \
									      \
	___x = (___u);							      \
									      \
	___b = (___v);							      \
									      \
	___a = ___b;							      \
									      \
	(___c) = (___s) < ___x ? (___s) : ___x;				      \
	if (SIZEOF_LONG & (SIZEOF_LONG - 1)) {				      \
	} else {							      \
	    if (((integral_q) ___a | (integral_q) (___n))		      \
		& (SIZEOF_LONG - 1)) {					      \
	    } else {							      \
		unsigned ___t;						      \
									      \
		___t = (___c);						      \
		scale(___t);						      \
		if (___t) {						      \
		    for (; ___t; ___t--) {				      \
			if (*(const long *) ___a ^ *(const long *) (___n)) {  \
			    break;					      \
			}						      \
									      \
			___a = (const void *) ((const long *) ___a + 1);      \
			(___n) = (const void *) ((const long *) (___n) + 1);  \
		    }							      \
									      \
		    (___c) -= ___a - ___b;				      \
		}							      \
	    }								      \
	}								      \
	for (; (___c); (___c)--) {					      \
	    ___f = *___a ^ *((unsigned char *) (___n));			      \
	    if (___f) {							      \
		if (1) {						      \
		    break;						      \
		}							      \
	    }								      \
									      \
	    ___a++;							      \
	    (___n)++;							      \
	}								      \
									      \
	if ((___c)) {							      \
	    if ((___s) < ___x) {					      \
		(___c) = (___s) - (___c);				      \
	    } else {							      \
		(___c) = ___x - (___c);					      \
	    }								      \
									      \
	    (___c) <<= 3;						      \
	    if (___f & 240) {						      \
	    } else {							      \
		(___c) += 4;						      \
		___f <<= 4;						      \
	    }								      \
	    if (___f & 192) {						      \
	    } else {							      \
		(___c) += 2;						      \
		___f <<= 2;						      \
	    }								      \
	    if (___f & 128) {						      \
	    } else {							      \
		(___c)++;						      \
	    }								      \
									      \
	    (___w) = *___a << ((___c) & 7) >> 7 & 1;			      \
	} else {							      \
	    if (1) {							      \
		Monday = 1;						      \
		if ((___s) < ___x) {					      \
		    (___c) = (___s) << 3;				      \
		    (___w) = 1;						      \
		} else {						      \
		    (___c) = ___x << 3;					      \
		    (___w) = 0;						      \
		}							      \
	    } else {							      \
	    }								      \
	}								      \
									      \
	(___n) -= (___c) >> 3;						      \
    }

#endif				/* __LIBx1f4_lsas_class_H__ */
