/*
 * lsas.e.c
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lsas-config.h>

#include <lsas-defs.h>
#include <lsas-inter.h>
#include <lsas-names.h>
#include <lsas-types.h>

#define lsnote(lsnote)			((struct lsnote_type *) (lsnote))

int
x1f4_flat_lsnote(void *lsnote)
{
    int status;

    status = _libx1f4l2_ceil_lsnote(lsnote);

#if __POST_SPLIT_CURE__ == __TREE_CURE__
    if (lsnote(lsnote)->link_m.free
	(lsnote(lsnote)->link_m.data, lsnote(lsnote)->link_e.mail)) {
	if (status) {
	} else {
	    status = FREE_ERROR;
	}
    }
#endif				/* __POST_SPLIT_CURE__ == __TREE_CURE__ */

    return status;
}
