/*
 * ncxx.r.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <ncxx-names.h>
#include <ncxx-types.h>

#define nclist(nclist)			((struct nclist_type *) (nclist))

int
_libx1f4l2_fair_nclist(void *ncdata, unsigned index, void *nctext,
		       unsigned order)
{
    struct fpnode_type *fpnode_data, *fqnode_data, *fxnode_data, *fznode_data;
    unsigned fast = 0, tilt = 0;

    fpnode_data = nclist(ncdata)->link_a.fplist.fplink.fpnode_data[0];
    fqnode_data = &nclist(ncdata)->link_a.fplist.fplink;

    while (1) {
	if (0) {
	} else {
	    unsigned class;

	    class = fpnode_data->fqnode.size;

	    if (index < class) {
		tilt = 0;
	    } else {
		if (class == index) {
		    break;
		} else {
		    class++;
		    index -= class;
		    tilt = 1;
		}
	    }
	}

	fqnode_data = fpnode_data;

	fpnode_data = fpnode_data->fpnode_data[tilt];
    }

    fxnode_data = nclist(nctext)->link_a.fplist.fplink.fpnode_data[0];
    fznode_data = &nclist(nctext)->link_a.fplist.fplink;

    while (1) {
	if (0) {
	} else {
	    unsigned class;

	    class = fxnode_data->fqnode.size;

	    if (order < class) {
		fast = 0;
	    } else {
		if (class == order) {
		    break;
		} else {
		    class++;
		    order -= class;
		    fast = 1;
		}
	    }
	}

	fznode_data = fxnode_data;

	fxnode_data = fxnode_data->fpnode_data[fast];
    }

    fqnode_data->fpnode_data[tilt] = fxnode_data;

    fznode_data->fpnode_data[fast] = fpnode_data;

    if (1) {
	struct fpnode_type fpnode_class;

	fpnode_class = *fpnode_data;
	*fpnode_data = *fxnode_data;
	*fxnode_data = fpnode_class;
    }

    return 0;
}
