/*
 * qlcc-lines.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_qlcc_lines_H__
#define __LIBx1f4_qlcc_lines_H__

#include <config.h>

#include <qlcc-types.h>

#if !defined Lx55555555
# if QLSIZE == SIZEOF_LONG
#  if SIZEOF_LONG == 4
#   define Lx55555555			0x0000fffful
#  else
#   define Lx55555555			0x00000000fffffffful
#  endif			/* SIZEOF_LONG == 4 */
# else
#  if SIZEOF_INT == 4
#   define Lx55555555			0x0000ffffu
#  else
#   define Lx55555555			0x00000000ffffffffu
#  endif			/* SIZEOF_INT == 4 */
# endif				/* QLSIZE == SIZEOF_LONG */
#endif				/* !Lx55555555 */

#if !defined Mx55555555
# if QLSIZE == SIZEOF_LONG
#  if SIZEOF_LONG == 4
#   define Mx55555555			0x55555555ul
#  else
#   define Mx55555555			0x5555555555555555ul
#  endif			/* SIZEOF_LONG == 4 */
# else
#  if SIZEOF_INT == 4
#   define Mx55555555			0x55555555u
#  else
#   define Mx55555555			0x5555555555555555u
#  endif			/* SIZEOF_INT == 4 */
# endif				/* QLSIZE == SIZEOF_LONG */
#endif				/* !Mx55555555 */

#if !defined Lx77777777
# if QLSIZE == SIZEOF_LONG
#  if SIZEOF_LONG == 4
#   define Lx77777777			0x00924924ul
#  else
#   define Lx77777777			0x0000924924924924ul
#  endif			/* SIZEOF_LONG == 4 */
# else
#  if SIZEOF_INT == 4
#   define Lx77777777			0x00924924u
#  else
#   define Lx77777777			0x0000924924924924u
#  endif			/* SIZEOF_INT == 4 */
# endif				/* QLSIZE == SIZEOF_LONG */
#endif				/* !Lx77777777 */

#if !defined Mxaaaaaaaa
# if QLSIZE == SIZEOF_LONG
#  if SIZEOF_LONG == 4
#   define Mxaaaaaaaa			0xaaaaaaaaul
#  else
#   define Mxaaaaaaaa			0xaaaaaaaaaaaaaaaaul
#  endif			/* SIZEOF_LONG == 4 */
# else
#  if SIZEOF_INT == 4
#   define Mxaaaaaaaa			0xaaaaaaaau
#  else
#   define Mxaaaaaaaa			0xaaaaaaaaaaaaaaaau
#  endif			/* SIZEOF_INT == 4 */
# endif				/* QLSIZE == SIZEOF_LONG */
#endif				/* !Mxaaaaaaaa */

#if 4
# if 2
#  if 1
#   define Lx00924924			Lx77777777
#  endif			/* 1 */
# endif				/* 2 */
#endif				/* 4 */

#endif				/* __LIBx1f4_qlcc_lines_H__ */
