/*
 * qlcw.5.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_hv11_qlrate(void *qlrate, unsigned index,
		       struct fpnode_type *fpnode_data, QLNODE copy)
{
#if SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1)
#else
    unsigned *deck;

    deck = fpnode_data->star;
    deck += index;
    if ((copy & Mxaaaaaaaa) >> 1 ^ (copy & Mx55555555)) {
	unsigned *near;

	near = deck + 2;
	*deck = *near;
	deck = near;
	copy >>= 1;
    }
    for (; copy; copy >>= 2) {
	unsigned *near;

	near = deck + 2;
	*deck = *near;
	deck = near + 2;
	*near = *deck;
    }
    {
	*deck = *(deck + 1);
    }
#endif				/* SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1) */

    return 0;
}
