/*
 * qxcc.8.c
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <qxcc-defs.h>
#include <qxcc-inter.h>
#include <qxcc-names.h>
#include <qxcc-types.h>

#define qxrate(qxrate)			((struct qxrate_type *) (qxrate))

int
x1f4_high_qxrate(void *qxrate)
{
    int status;

    status = _libx1f4l2_ceil_qxrate(qxrate);
    if (status) {
    } else {
	qxrate(qxrate)->link_e.fplink_data = NULL;
	qxrate(qxrate)->link_e.fplink_text = NULL;

	qxrate(qxrate)->link_a.fplist.size = 0;

	if (qxrate(qxrate)->link_a.fplist.rate) {
	    void *data;

	    data = qxrate(qxrate)->link_a.fplist.fpnode_data;

	    status = qxrate(qxrate)->link_m.mode
		(qxrate(qxrate)->link_m.data, &data,
		 qxrate(qxrate)->link_a.fplist.mall * 3
		 * qxrate(qxrate)->link_a.fplist.lock >> 1);
	    if (status) {
		status = MODE_ERROR;
	    } else {
		qxrate(qxrate)->link_a.fplist.rate = 0;
		if (1) {
		    qxrate(qxrate)->link_a.fplist.fpnode_data = data;
		}
	    }
	}
    }

    return status;
}
