/*
 * qxcc.j.c
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qxcc-config.h>

#include <string.h>

#include <qxcc-bits.h>
#include <qxcc-inter.h>
#include <qxcc-names.h>
#include <qxcc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qxrate(qxrate)			((struct qxrate_type *) (qxrate))

int
_libx1f4l2_blue_qxrate(void *qxrate, void *node)
{
    int status;
    unsigned epnode, mall, scnode, sfnode;
    void *side;

    mall = qxrate(qxrate)->link_a.fplist.mall;

    status = qxrate(qxrate)->link_m.link
	(qxrate(qxrate)->link_m.data, &side,
	 qxrate(qxrate)->link_a.fplist.line * mall);
    if (status) {
	status = _libx1f4l2_rack_qxrate(qxrate, 0, &side);
    }

    epnode = P_ROOT(Q_NODE(node));

    if (0) {
    } else {
	unsigned epslip;
	void *lcnode, *lsslip;

	epslip = Q_NODE(node);

	scnode = P_LIST(epslip);

	lcnode = M_TEXT(node, scnode);

	sfnode = Q_NODE(lcnode);

	lsslip = M_TEXT(node, sfnode);

#if ____CLASS_INSERT__ == __SLICE_INSERT__
	S_NODE(node, B_LIST(Q_NODE(lsslip)) | M_ROOT(epslip));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

	S_NODE(M_TEXT(lcnode, sizeof(unsigned)), 1);

	lsslip = M_TEXT(node, 0);

	epslip = Q_NODE(lsslip);

#if ____CLASS_INSERT__ == __SLICE_INSERT__
	if (0) {
	} else {
	    S_NODE(lsslip, E_NEXT(epslip) | B_NEXT(scnode));
	}
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

	if (0) {
	} else {
	    unsigned count, half, line, mail;
	    void *late, **lise;

	    S_NODE(lcnode, B_LAST(epnode) | B_NEXT(sfnode) | B_TILT(0));

	    late = *(void **) M_TEXT(node, epnode);
	    lise = M_TEXT(node, sfnode);
	    *lise = side;

	    line = 3 * qxrate(qxrate)->link_a.fplist.line >> 1;
	    mail = line >> 1;
	    half = mail * mall;
	    memcpy(side, (char *) late + mail * mall, (line - mail) * mall);
	    lise = M_TEXT(node, epnode);
	    if (qxrate(qxrate)->link_m.mode
		(qxrate(qxrate)->link_m.data, lise,
		 qxrate(qxrate)->link_a.fplist.line * mall)) {
	    } else {
		late = *lise;
	    }
	    count = mail;
	    if (0) {
	    } else {
		S_NODE(M_TEXT(node, scnode + sizeof(unsigned)), count);
	    }
	}
    }

    return status;
}
