/*
 * sjxx-inter.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_sjxx_inter_H__
#define __LIBx1f4_sjxx_inter_H__

#include <sjxx-names.h>
#include <sjxx-types.h>

#define _libx1f4l2_fast_sjdeck		x1f4_fast_sjdeck
#define _libx1f4l2_flat_sjdeck		x1f4_flat_sjdeck

extern int _libx1f4l2_blue_sjdeck
    (void *, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_fail_sjdeck(void *, struct fpnode_type *);
extern int _libx1f4l2_fast_sjdeck(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_flat_sjdeck(void *);

#endif				/* __LIBx1f4_sjxx_inter_H__ */
