/*
 * slxi.j.c
 * Copyright (C) 2009, 2010, 2011, 2012, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <slxx-defs.h>
#include <slxx-names.h>
#include <slxx-types.h>

#define sldeck(sldeck)			((struct sldeck_type *) (sldeck))

int
_libx1f4l2_fail_sldeck(void *sldeck, struct fpnode_type *fpnode_data)
{
    int status;

    do {
	if (sizeof(byte *) < length(fpnode_data)) {
	    status = sldeck(sldeck)->link_m.free
		(sldeck(sldeck)->link_m.data, fpnode_data->base);
	    if (status) {
		status = FREE_ERROR;

		break;
	    }
	}

	status = 0;

	if (0) {
	} else {
	    sldeck(sldeck)->link_a.fpdeck.fpnode.bits = lset();
	}
    } while (0);

    return status;
}
