/*
 * tcxx.n.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcxx-names.h>
#include <tcxx-types.h>

#define tclist(tclist)			((struct tclist_type *) (tclist))

int
_libx1f4l2_lane_tclist(void *tclist, unsigned index, unsigned order)
{
    struct fpnode_type *fpnode_data, *fqnode_data, *fxnode_data, *fznode_data;
    unsigned fast = 0, tilt = 0;

    fpnode_data = tclist(tclist)->link_a.fplist.fplink.fpnode_data[0];
    fqnode_data = &tclist(tclist)->link_a.fplist.fplink;

    while (1) {
	unsigned class;

	class = fpnode_data->fqnode.size;
	if (class == 1) {
	    break;
	} else {
	    struct fpnode_type *fpnode_miss;

	    fpnode_miss = fpnode_data->fpnode_data[0];
	    if (!fpnode_miss) {
		if (!index) {
		    break;
		} else {
		    if (0) {
		    } else {
			index--;
			tilt = 1;
		    }
		}
	    } else {
		unsigned Class;

		Class = fpnode_miss->fqnode.size;
		if (Class == index) {
		    break;
		} else {
		    if (index < Class) {
			tilt = 0;
		    } else {
			index -= Class + 1;
			tilt = 1;
		    }
		}
	    }
	}

	fqnode_data = fpnode_data;

	fpnode_data = fpnode_data->fpnode_data[tilt];
    }

    fxnode_data = tclist(tclist)->link_a.fplist.fplink.fpnode_data[0];
    fznode_data = &tclist(tclist)->link_a.fplist.fplink;

    while (1) {
	unsigned class;

	class = fxnode_data->fqnode.size;
	if (class == 1) {
	    break;
	} else {
	    struct fpnode_type *fxnode_miss;

	    fxnode_miss = fxnode_data->fpnode_data[0];
	    if (!fxnode_miss) {
		if (!order) {
		    break;
		} else {
		    if (0) {
		    } else {
			order--;
			fast = 1;
		    }
		}
	    } else {
		unsigned Class;

		Class = fxnode_miss->fqnode.size;
		if (Class == order) {
		    break;
		} else {
		    if (order < Class) {
			fast = 0;
		    } else {
			order -= Class + 1;
			fast = 1;
		    }
		}
	    }
	}

	fznode_data = fxnode_data;

	fxnode_data = fxnode_data->fpnode_data[fast];
    }

    fqnode_data->fpnode_data[tilt] = fxnode_data;

    fznode_data->fpnode_data[fast] = fpnode_data;

    if (1) {
	struct fpnode_type fpnode_class;

	fpnode_class = *fpnode_data;
	*fpnode_data = *fxnode_data;
	*fxnode_data = fpnode_class;
    }

    return 0;
}
