/*
 * tcxx.y.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcxx-defs.h>
#include <tcxx-names.h>
#include <tcxx-types.h>

#define tclist(tclist)			((struct tclist_type *) (tclist))

int
_libx1f4l2_here_tclist(void *tclist, unsigned size, void **push)
{
    int status;
    void *tcnode;

    status = tclist(tclist)->link_m.link
	(tclist(tclist)->link_m.data, &tcnode,
	 sizeof(struct fpnode_type) + size);
    if (status) {
	status = LINK_ERROR;
    } else {
	*push = tcnode;
    }

    return status;
}
