/*
 * tfqp.a.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tfqp-inter.h>
#include <tfqp-names.h>
#include <tfqp-types.h>

#define tfline(tfline)			((struct tfline_type *) (tfline))

int
x1f4_high_tfline(void *tfline)
{
    int status;

    status = _libx1f4l2_ceil_tfline(tfline);
    if (status) {
    } else {
	tfline(tfline)->link_a.fpline.fplink.fpnode_data[0] = NULL;
	tfline(tfline)->link_a.fpline.fplink.fqnode.fine = 0;
    }

    return status;
}
