/*
 * tvxx.4.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tvxx-defs.h>
#include <tvxx-inter.h>
#include <tvxx-names.h>
#include <tvxx-types.h>

#define tvlist(tvlist)			((struct tvlist_type *) (tvlist))

int
x1f4_peek_tvlist(void *tvlist, unsigned index, void **peek)
{
    int status;

    if (!(index < tvlist(tvlist)->link_a.fplist.fplink.fqnode.size)) {
	status = DECK_ERROR;
    } else {
	void *tvnode;

	status = 0;

	_libx1f4l2_else_tvlist(tvlist, index, &tvnode);

	*peek = ((struct fpnode_type *) tvnode) + 1;
    }

    return status;
}
