/*
 * tvxx.g.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tvxx-names.h>
#include <tvxx-types.h>

#define __HALF_SELECT__			1
#define __MISS_SINGLE__			1

#if __HALF_SELECT__
# undef __MISS_SINGLE__
# define __MISS_SINGLE__		0
#endif				/* __HALF_SELECT__ */

#define __TEST_SINGLE__			(!__MISS_SINGLE__)

#define false(e)			0

#define tvlist(tvlist)			((struct tvlist_type *) (tvlist))

int
_libx1f4l2_else_tvlist(void *tvlist, unsigned index, void **seek)
{
    struct fpnode_type *fpnode_data;
#if __TEST_SINGLE__
    unsigned class;
#endif				/* __TEST_SINGLE__ */

    fpnode_data = tvlist(tvlist)->link_a.fplist.fplink.fpnode_data[0];

#if __TEST_SINGLE__
    class = fpnode_data->fqnode.size;
#endif				/* __TEST_SINGLE__ */

    while (1) {
#if __TEST_SINGLE__
	if (false(class == 1)) {
	    break;
	} else {
#endif				/* __TEST_SINGLE__ */
#if __HALF_SELECT__
	    if (class < index << 1) {
		struct fpnode_type *fpnode_miss;

		fpnode_miss = fpnode_data->fpnode_data[1];
		if (!fpnode_miss) {
		    if (class == index + 1) {
			break;
		    } else {
			if (0) {
			} else {
			    fpnode_data = fpnode_data->fpnode_data[0];
			    class--;
			}
		    }
		} else {
		    unsigned shift;

		    shift = fpnode_miss->fqnode.size;
		    class -= shift;
		    if (index < class) {
			if (class == index + 1) {
			    break;
			} else {
			    fpnode_data = fpnode_data->fpnode_data[0];
			    class--;
			}
		    } else {
			index -= class;
			fpnode_data = fpnode_miss;
			class = shift;
		    }
		}
	    } else {
#endif				/* __HALF_SELECT__ */
		struct fpnode_type *fpnode_miss;

		fpnode_miss = fpnode_data->fpnode_data[0];
		if (!fpnode_miss) {
		    if (!index) {
			break;
		    } else {
			if (0) {
			} else {
			    index--;
			    fpnode_data = fpnode_data->fpnode_data[1];
#if __TEST_SINGLE__
			    class--;
#endif				/* __TEST_SINGLE__ */
			}
		    }
		} else {
		    unsigned shift;

		    shift = fpnode_miss->fqnode.size;
		    if (index < shift) {
			fpnode_data = fpnode_miss;
#if __TEST_SINGLE__
			class = shift;
#endif				/* __TEST_SINGLE__ */
		    } else {
			if (shift == index) {
			    break;
			} else {
			    shift++;
			    index -= shift;
			    fpnode_data = fpnode_data->fpnode_data[1];
#if __TEST_SINGLE__
			    class -= shift;
#endif				/* __TEST_SINGLE__ */
			}
		    }
		}
#if __HALF_SELECT__
	    }
#endif				/* __HALF_SELECT__ */
#if __TEST_SINGLE__
	}
#endif				/* __TEST_SINGLE__ */
    }

    *seek = fpnode_data;

    return 0;
}
