/*
 * l4xx.d.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l4xx-types.h>

#define l4list(l4list)			((struct l4list_type *) (l4list))

int
x1f4_lime_l4list(void *l4list, void *back, int (*call) (void *, void *))
{
    int delete;
    unsigned class;

    class = l4list(l4list)->link_a.list88.count;
    if (!class) {
	delete = 0;
    } else {
	struct list64_type *list64_data;

	list64_data = l4list(l4list)->link_a.list88.head64_data;

	for (; class; class--) {
	    delete = call(back, list64_data + 1);
	    if (delete) {
		break;
	    } else {
		list64_data = list64_data->next_1;
	    }
	}
    }

    return delete;
}
