/*
 * l4xx.g.c
 * Copyright (C) 2007-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l4xx-list.h>
#include <l4xx-types.h>

#define list88(push88)			((struct list88_type *) (push88))

int
_libx1f4l2_back_l4list(void *list88, void **list64, unsigned this)
{
    struct list64_type *list64_data;
    unsigned stride;

    list64_data = *list64;

    stride = list88(list88)->stride;
    SCALE_LIST(list64_data, stride, last_0, this);
    SHIFT_LIST(list64_data, stride, last_1, this);

    *list64 = list64_data;

    return 0;
}


int
_libx1f4l2_lock_l4list(void *list88, void **list64, unsigned this)
{
    struct list64_type *list64_data;
    unsigned stride;

    list64_data = *list64;

    stride = list88(list88)->stride;
    SCALE_LIST(list64_data, stride, next_7, this);
    SHIFT_LIST(list64_data, stride, next_1, this);

    *list64 = list64_data;

    return 0;
}
