/*
 * lvxx.g.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lvxx-names.h>
#include <lvxx-types.h>

#define false(e)			0

#define lvlist(lvlist)			((struct lvlist_type *) (lvlist))

int
_libx1f4l2_else_lvlist(void *lvlist, unsigned index, void **seek)
{
    struct fpnode_type *fpnode_data;
    unsigned shift;

    fpnode_data = &lvlist(lvlist)->link_a.fplist.fplink;

    shift = fpnode_data->fqnode.size;

    fpnode_data = fpnode_data->fpnode_data[0];

    while (1) {
	if (false(shift == 1)) {
	    break;
	} else {
	    unsigned class;

	    class = fpnode_data->fqnode.size;

	    if (class & 1) {
		class >>= 1;
		shift -= class;
		if (index < shift) {
		    shift--;
		    if (shift == index) {
			break;
		    } else {
			fpnode_data = fpnode_data->fpnode_data[0];
		    }
		} else {
		    index -= shift;
		    fpnode_data = fpnode_data->fpnode_data[1];
		    shift = class;
		}
	    } else {
		class >>= 1;
		if (index < class) {
		    fpnode_data = fpnode_data->fpnode_data[0];
		    shift = class;
		} else {
		    if (class == index) {
			break;
		    } else {
			class++;
			index -= class;
			fpnode_data = fpnode_data->fpnode_data[1];
			shift -= class;
		    }
		}
	    }
	}
    }

    *seek = fpnode_data;

    return 0;
}
