/*
 * ncxx.v.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <ncxx-config.h>

#include <stddef.h>

#include <ncxx-inter.h>
#include <ncxx-names.h>
#include <ncxx-types.h>

#define nclist(nclist)			((struct nclist_type *) (nclist))

int
_libx1f4l2_beta_nclist(void *nclist, void *ncnode)
{
    struct fpnode_type *fpnode_data, *fqnode_data, *fxnode_data, *fznode_data;

    fxnode_data = nclist(nclist)->link_a.fplist.fplink.fpnode_data[0];
    fznode_data = &nclist(nclist)->link_a.fplist.fplink;

    fpnode_data = fxnode_data;
    fqnode_data = fznode_data;

    while (fpnode_data) {
	if (fpnode_data->fqnode.tilt) {
	    fxnode_data = fpnode_data;
	    fznode_data = fqnode_data;
	}

	fqnode_data = fpnode_data;
	fpnode_data = fpnode_data->fpnode_data[1];
    }

    if (0) {
    } else {
	struct fpnode_type *fnnode_data;

	fnnode_data = ncnode;

	fnnode_data->fpnode_data[0] = NULL;
	fnnode_data->fpnode_data[1] = NULL;

	fnnode_data->fqnode.size = 0;
	fnnode_data->fqnode.tilt = 0;

	if (!fxnode_data) {
	    fqnode_data->fpnode_data[0] = fnnode_data;
	} else {
	    fqnode_data->fpnode_data[1] = fnnode_data;

	    fpnode_data = fxnode_data;

	    do {
		if (1) {
		    fpnode_data->fqnode.tilt++;
		}

		fpnode_data = fpnode_data->fpnode_data[1];
	    } while (fpnode_data != fnnode_data);

	    if (fxnode_data->fqnode.tilt == 2) {
		if (1) {
		    struct fpnode_type *fvnode_data, *fwnode_data;

		    fvnode_data = fxnode_data->fpnode_data[1];
		    if (fvnode_data->fqnode.tilt == 1) {
			fwnode_data = fvnode_data;
			fxnode_data->fpnode_data[1] =
			    fvnode_data->fpnode_data[0];
			fvnode_data->fpnode_data[0] = fxnode_data;
			fvnode_data->fqnode.tilt = 0;
			fxnode_data->fqnode.tilt = 0;
			if (1) {
			    fvnode_data->fqnode.size +=
				fxnode_data->fqnode.size + 1;
			}
		    } else {
			int slip;

			fwnode_data = fvnode_data->fpnode_data[0];
			fvnode_data->fpnode_data[0] =
			    fwnode_data->fpnode_data[1];
			fwnode_data->fpnode_data[1] = fvnode_data;
			fxnode_data->fpnode_data[1] =
			    fwnode_data->fpnode_data[0];
			fwnode_data->fpnode_data[0] = fxnode_data;
			slip = fwnode_data->fqnode.tilt;
			fwnode_data->fqnode.tilt = 0;
			if (slip == 1) {
			    fvnode_data->fqnode.tilt = 0;
			    fxnode_data->fqnode.tilt = -1;
			} else {
			    if (!slip) {
				fvnode_data->fqnode.tilt = 0;
				fxnode_data->fqnode.tilt = 0;
			    } else {
				fvnode_data->fqnode.tilt = 1;
				fxnode_data->fqnode.tilt = 0;
			    }
			}
			{
			    fvnode_data->fqnode.size -=
				fwnode_data->fqnode.size + 1;
			    fwnode_data->fqnode.size +=
				fxnode_data->fqnode.size + 1;
			}
		    }
		    if (fxnode_data == fznode_data->fpnode_data[0]) {
			fznode_data->fpnode_data[0] = fwnode_data;
		    } else {
			fznode_data->fpnode_data[1] = fwnode_data;
		    }
		}
	    }
	}
    }

    return 0;
}
