/*
 * nvxx.u.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <nvxx-names.h>
#include <nvxx-types.h>

#define nvlist(nvlist)			((struct nvlist_type *) (nvlist))

int
_libx1f4l2_dana_nvlist(void *nvlist, void *nvnode)
{
    struct fpnode_type *fpnode_data, *fqnode_data, *fxnode_data;

    fxnode_data = nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[0];

    fpnode_data = fxnode_data;
    fqnode_data = &nvlist(nvlist)->link_a.fplist.fplink;

    while (fpnode_data) {
	unsigned class;

	class = fpnode_data->fqnode.size;
	if (0) {
	} else {
	    if (0) {
	    } else {
		if (0) {
		} else {
		    fpnode_data->fqnode.size = class + 1;
		}
	    }
	}

	if (fpnode_data->fqnode.tilt) {
	    fxnode_data = fpnode_data;
	}

	fqnode_data = fpnode_data;
	fpnode_data = fpnode_data->fpnode_data[0];
    }

    if (0) {
    } else {
	struct fpnode_type *fnnode_data;

	fnnode_data = nvnode;

	fnnode_data->fpnode_data[0] = NULL;
	fnnode_data->fpnode_data[1] = NULL;

	fnnode_data->fqnode.size = 0;
	fnnode_data->fqnode.tilt = 0;

	if (!fxnode_data) {
	    fnnode_data->uplink_data = NULL;

	    fqnode_data->fpnode_data[0] = fnnode_data;
	} else {
	    fqnode_data->fpnode_data[0] = fnnode_data;

	    fpnode_data = fnnode_data;

	    fnnode_data->uplink_data = fqnode_data;

	    do {
		fqnode_data = fpnode_data->uplink_data;
		if (1) {
		    fqnode_data->fqnode.tilt--;
		}

		fpnode_data = fqnode_data;
	    } while (fpnode_data != fxnode_data);

	    if (fxnode_data->fqnode.tilt == -2) {
		if (1) {
		    struct fpnode_type *fvnode_data, *fwnode_data;

		    fvnode_data = fxnode_data->fpnode_data[0];
		    if (fvnode_data->fqnode.tilt == -1) {
			struct fpnode_type *fmnode_data;

			fwnode_data = fvnode_data;
			fmnode_data = fvnode_data->fpnode_data[1];
			fxnode_data->fpnode_data[0] = fmnode_data;
			fvnode_data->fpnode_data[1] = fxnode_data;
			fvnode_data->fqnode.tilt = 0;
			fxnode_data->fqnode.tilt = 0;
			fvnode_data->uplink_data = fxnode_data->uplink_data;
			fxnode_data->uplink_data = fvnode_data;
			if (fmnode_data) {
			    fmnode_data->uplink_data = fxnode_data;
			} else {
			}
			if (1) {
			    fxnode_data->fqnode.size -=
				fvnode_data->fqnode.size + 1;
			}
		    } else {
			int slip;
			struct fpnode_type *fbnode_data, *fdnode_data;

			fwnode_data = fvnode_data->fpnode_data[1];
			fbnode_data = fwnode_data->fpnode_data[0];
			fvnode_data->fpnode_data[1] = fbnode_data;
			fwnode_data->fpnode_data[0] = fvnode_data;
			fdnode_data = fwnode_data->fpnode_data[1];
			fxnode_data->fpnode_data[0] = fdnode_data;
			fwnode_data->fpnode_data[1] = fxnode_data;
			slip = fwnode_data->fqnode.tilt;
			fwnode_data->fqnode.tilt = 0;
			if (slip == -1) {
			    fvnode_data->fqnode.tilt = 0;
			    fxnode_data->fqnode.tilt = 1;
			} else {
			    if (!slip) {
				fvnode_data->fqnode.tilt = 0;
				fxnode_data->fqnode.tilt = 0;
			    } else {
				fvnode_data->fqnode.tilt = -1;
				fxnode_data->fqnode.tilt = 0;
			    }
			}
			fwnode_data->uplink_data = fxnode_data->uplink_data;
			fvnode_data->uplink_data = fwnode_data;
			fxnode_data->uplink_data = fwnode_data;
			if (fbnode_data) {
			    fbnode_data->uplink_data = fvnode_data;
			} else {
			}
			if (fdnode_data) {
			    fdnode_data->uplink_data = fxnode_data;
			} else {
			}
			{
			    fwnode_data->fqnode.size +=
				fvnode_data->fqnode.size + 1;
			    fxnode_data->fqnode.size -=
				fwnode_data->fqnode.size + 1;
			}
		    }
		    fvnode_data = fwnode_data->uplink_data;
		    if (fvnode_data) {
			if (fxnode_data == fvnode_data->fpnode_data[0]) {
			    fvnode_data->fpnode_data[0] = fwnode_data;
			} else {
			    fvnode_data->fpnode_data[1] = fwnode_data;
			}
		    } else {
			nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[0] =
			    fwnode_data;
		    }
		}
	    }
	}
    }

    return 0;
}

