/*
 * qccc-inter.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_qccc_inter_H__
#define __LIBx1f4_qccc_inter_H__

#include <qccc-names.h>
#include <qccc-types.h>

#if !defined _libx1f4l2_fast_qcrate
# define _libx1f4l2_fast_qcrate		x1f4_fast_qcrate
#endif				/* !_libx1f4l2_fast_qcrate */
#if !defined _libx1f4l2_flat_qcrate
# define _libx1f4l2_flat_qcrate		x1f4_flat_qcrate
#endif				/* !_libx1f4l2_flat_qcrate */

extern int _libx1f4l2_blue_qcrate(void *, unsigned, unsigned, void **);
extern int _libx1f4l2_ceil_qcrate(void *);
extern int _libx1f4l2_fall_qcrate(void *);
extern int _libx1f4l2_fast_qcrate(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_flat_qcrate(void *);
extern int _libx1f4l2_gray_qcrate
    (void *, unsigned, void *, unsigned, unsigned *, void **);
extern int _libx1f4l2_mold_qcrate(void *, void *, unsigned, unsigned *);
extern int _libx1f4l2_part_qcrate(void *, void *, unsigned, unsigned);
extern int _libx1f4l2_rack_qcrate(void *, unsigned, void **);
extern int _libx1f4l2_root_qcrate(void *, void **);
extern int _libx1f4l2_type_qcrate(void *, unsigned, unsigned);

#endif				/* __LIBx1f4_qccc_inter_H__ */
