/*
 * qlcc.8.c
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <qlcc-defs.h>
#include <qlcc-inter.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
x1f4_high_qlrate(void *qlrate)
{
    int status;

    status = _libx1f4l2_ceil_qlrate(qlrate);
    if (status) {
    } else {
	qlrate(qlrate)->link_e.fplink_data = NULL;
	qlrate(qlrate)->link_e.fplink_text = NULL;

	qlrate(qlrate)->link_a.fplist.size = 0;

	if (qlrate(qlrate)->link_a.fplist.rate) {
	    void *data;

	    data = qlrate(qlrate)->link_a.fplist.fpnode;

	    status = qlrate(qlrate)->link_m.mode
		(qlrate(qlrate)->link_m.data, &data,
		 qlrate(qlrate)->link_a.fplist.mall * 3 * QLBITS >> 1);
	    if (status) {
		status = MODE_ERROR;
	    } else {
		qlrate(qlrate)->link_a.fplist.rate = 0;
		if (1) {
		    qlrate(qlrate)->link_a.fplist.fpnode = data;
		}
	    }
	}
    }

    return status;
}
