/*
 * qlch.0.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define dana(___s, ___n) \
    (___s) = (char *) (___s) + ((___n) << 1)

#define sans(___s, ___n) \
    ((char *) (___s) + (___n))

#define skip(___s, ___n) \
    (___s) = (char *) (___s) + (___n)

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_rv00_qlrate(void *qlrate, unsigned index,
		       struct fpnode_type *fpnode_data,
		       struct fpnode_type *fpnode_last)
{
    unsigned mall;
    void *fpnode, *fqnode;

    mall = qlrate(qlrate)->link_a.fplist.mall;

    if (0) {
    } else {
	unsigned i;

	fqnode = fpnode_last->star;

	skip(fqnode, mall);

	fpnode = sans(fqnode, mall);

	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    memcpy(fqnode, fpnode, mall);
	    skip(fqnode, mall);
	    dana(fpnode, mall);
	}

	fpnode = fpnode_data->star;

	i = index & ~1;
	for (; i; i--) {
	    memcpy(fqnode, fpnode, mall);
	    skip(fqnode, mall);
	    dana(fpnode, mall);
	}

	if (index & 1) {
	    memcpy(fqnode, fpnode, mall);
	    dana(fpnode, mall);
	    index--;
	} else {
	    dana(fpnode, mall);
	    memcpy(fqnode, fpnode, mall);
	}

	if (qlrate(qlrate)->link_a.fplist.size == QLBITS - 1) {
	} else {
	    skip(fqnode, mall);
	}

	i = (QLBITS >> 1) - 2 - index;
	for (; i; i--) {
	    dana(fpnode, mall);
	    skip(fqnode, mall);
	    memcpy(fqnode, fpnode, mall);
	}
    }

    fpnode_data->node = ~(QLNODE) 0;
    fpnode_last->node = (QLNODE) 1 << (HALF_QLBITS + index);

    return 0;
}
