/*
 * qlcp.0.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_cs00_qlrate(void *qlrate, unsigned index, void *sale, void *side,
		       QLNODE *news, void **push)
{
    unsigned half, i, mall;
    void *deck, *near;

    mall = qlrate(qlrate)->link_a.fplist.mall;

    half = QLBITS * mall >> 1;

    deck = side;
    near = (char *) sale + half;

    if (index < QLBITS >> 1) {
	{
	    near = (char *) near - mall * 1;
	    memcpy(deck, near, mall);
	    deck = (char *) deck + mall * 1;
	    near = (char *) near + mall * 1;
	    memcpy(deck, near, mall);
	    deck = (char *) deck + mall * 1;
	    near = (char *) near + mall * 1;
	}
	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    memcpy(deck, near, mall);
	    deck = (char *) deck + mall * 2;
	    near = (char *) near + mall * 1;
	}

	deck = (char *) sale + (half << 1);
	near = (char *) sale + half;

	near = (char *) near - mall;

	i = (QLBITS >> 1) - 1 - index;
	for (; i; i--) {
	    deck = (char *) deck - mall * 2;
	    near = (char *) near - mall * 1;
	    memcpy(deck, near, mall);
	}

	{
	    deck = (char *) deck - mall * 2;
	    *push = deck;
	}

	i = index;
	if (i) {
	    i--;
	    for (; i; i--) {
		deck = (char *) deck - mall * 2;
		near = (char *) near - mall * 1;
		memcpy(deck, near, mall);
	    }
	}

	{
	    *news = (Lx55555555 & ~(QLNODE) 1) << 1;
	}
    } else {
	index -= QLBITS >> 1;

	if (index) {
	    memcpy(deck, near, mall);
	    deck = (char *) deck + mall * 2;
	    near = (char *) near + mall * 1;
	} else {
	    deck = (char *) deck + mall * 1;
	    memcpy(deck, near, mall);
	    deck = (char *) deck + mall * 1;
	    near = (char *) near + mall * 1;
	}
	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    memcpy(deck, near, mall);
	    deck = (char *) deck + mall * 2;
	    near = (char *) near + mall * 1;
	}

	deck = (char *) sale + (half << 1);
	near = (char *) sale + half;

	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    deck = (char *) deck - mall * 2;
	    near = (char *) near - mall * 1;
	    memcpy(deck, near, mall);
	}

	if (index) {
	    *news = (Lx55555555 & (((QLNODE) 1 << (index - 1)) - 1))
		| (Lx55555555 & ~(QLNODE) 0 << (index - 1 + 1)) << 1;
	    *push = (char *) side + ((index << 1) - 1) * mall;
	} else {
	    *news = (Lx55555555 & ~(QLNODE) 1) << 1;
	    *push = side;
	}
    }

    return 0;
}
