/*
 * qxcc.g.c
 * Copyright (C) 2009-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qxcc-bits.h>
#include <qxcc-defs.h>
#include <qxcc-inter.h>
#include <qxcc-names.h>
#include <qxcc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

int
_libx1f4l2_type_qxrate(void *node, unsigned copy, unsigned size)
{
    unsigned list = 0, text;
    void *side;

    text = copy * sizeof(unsigned) << 1;

    side = M_TEXT(node, text);

    copy--;
    for (; copy; copy--) {
	S_NODE(node, text);
	text += size;
	list += sizeof(unsigned) << 1;
	S_NODE(side, list);
	side = M_TEXT(side, size);
	node = M_TEXT(node, sizeof(unsigned));
	S_NODE(node, copy);
	node = M_TEXT(node, sizeof(unsigned));
    }
    {
	S_NODE(node, text);
	node = M_TEXT(node, sizeof(unsigned));
	S_NODE(node, 0);
	S_NODE(side, 0);
    }

    return 0;
}
