/*
 * s8xx-inter.h
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_s8xx_inter_H__
#define __LIBx1f4_s8xx_inter_H__

#include <s8xx-names.h>
#include <s8xx-types.h>

#define _libx1f4l2_fast_s8deck		x1f4_fast_s8deck
#define _libx1f4l2_flat_s8deck		x1f4_flat_s8deck

extern int _libx1f4l2_fast_s8deck(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_flat_s8deck(void *);

#endif				/* __LIBx1f4_s8xx_inter_H__ */
