/*
 * tcml.m.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tcmn-bits.h>
#include <tcmn-names.h>
#include <tcmn-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

static int find_list(void *, unsigned, unsigned, unsigned, void **);

static int
find_list(void *tcmini, unsigned node, unsigned text, unsigned offset,
	  void **find)
{
    int delete;
    void *record = NULL;

    offset += 4;

    while (1) {
	void *extend;

	extend = M_TEXT(tcmini, node);

	if (0) {
	} else {
	    if (*(unsigned *) M_TEXT(extend, offset) < text) {
		record = extend;

		node = L_NEXT(Q_NODE(extend));
		if (node) {
		} else {
		    break;
		}
	    } else {
		node = L_LAST(Q_NODE(extend));
		if (node) {
		} else {
		    break;
		}
	    }
	}
    }

    if (record) {
	delete = 1;
	if (1) {
	    *find = (char *) record + 4;
	}
    } else {
	delete = 0;
    }

    return delete;
}


int
x1f4_llxd_tcfare(void *tcmini, unsigned text, unsigned slip, void **find)
{
    int delete;
    unsigned root;

    root = P_ROOT(Q_NODE(tcmini));
    if (root) {
	delete = find_list(tcmini, root, text, slip, find);
    } else {
	delete = 0;
    }

    return delete;
}
