/*
 * tcqb.0.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcqp-names.h>
#include <tcqp-types.h>
#include <trans.h>

#define tcline(tcline)			((struct tcline_type *) (tcline))

int
x1f4_skew_tcline(void *tcline, void *trans)
{
    tcline(tcline)->link_m.data = ((struct trans_type *) trans)->data;
    tcline(tcline)->link_m.free = ((struct trans_type *) trans)->free;
    tcline(tcline)->link_m.link = ((struct trans_type *) trans)->link;
    tcline(tcline)->link_m.mode = ((struct trans_type *) trans)->mode;

    return 0;
}
