/*
 * tqqp-inter.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_tqqp_inter_H__
#define __LIBx1f4_tqqp_inter_H__

#include <tqqp-names.h>
#include <tqqp-types.h>

#define _libx1f4l2_fast_tqline		x1f4_fast_tqline
#define _libx1f4l2_flat_tqline		x1f4_flat_tqline

extern int _libx1f4l2_beta_tqline(void *, unsigned, void **);
extern int _libx1f4l2_ceil_tqline(void *);
extern int _libx1f4l2_dana_tqline(void *, void *);
extern int _libx1f4l2_elif_tqline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_even_tqline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_fast_tqline(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_flat_tqline(void *);
extern int _libx1f4l2_nand_tqline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));

#endif				/* __LIBx1f4_tqqp_inter_H__ */
