/*
 * tsqp-inter.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_tsqp_inter_H__
#define __LIBx1f4_tsqp_inter_H__

#include <tsqp-names.h>
#include <tsqp-types.h>

#define _libx1f4l2_fast_tsline		x1f4_fast_tsline
#define _libx1f4l2_flat_tsline		x1f4_flat_tsline

extern int _libx1f4l2_beta_tsline(void *, unsigned, void **);
extern int _libx1f4l2_ceil_tsline(void *);
extern int _libx1f4l2_dana_tsline(void *, void *);
extern int _libx1f4l2_elif_tsline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_even_tsline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_fast_tsline(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_flat_tsline(void *);
extern int _libx1f4l2_nand_tsline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int _libx1f4l2_wave_tsline
    (void *, void *, void *, int (*) (void *, void *));

#endif				/* __LIBx1f4_tsqp_inter_H__ */
