/*
 * tvqp.3.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tvqp-defs.h>
#include <tvqp-names.h>
#include <tvqp-types.h>

#define tvline(tvline)			((struct tvline_type *) (tvline))

int
x1f4_lead_tvline(void *tvline, void **peek)
{
    int status;

    if (!tvline(tvline)->link_a.fpline.fplink.fpnode_data[0]) {
	status = DECK_ERROR;
    } else {
	struct fpnode_type *fpnode_data;

	status = 0;

	fpnode_data = tvline(tvline)->link_a.fpline.fplink.fpnode_data[0];

	while (1) {
	    struct fpnode_type *fqnode_data;

	    fqnode_data = fpnode_data->fpnode_data[0];
	    if (fqnode_data) {
		fpnode_data = fqnode_data->fpnode_data[0];
		if (fpnode_data) {
		} else {
		    *peek = fqnode_data + 1;
		    if (1) {
			break;
		    }
		}
	    } else {
		*peek = fpnode_data + 1;
		if (1) {
		    break;
		}
	    }
	}
    }

    return status;
}
