/*
 * l2xx.h
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4l2_L2XX_H__
#define __LIBx1f4l2_L2XX_H__

/*
 * doubly linked list
 */
#define __L2LIST__			1

/*
 * xor linked list
 */
#define __DFLIST__			2

#define __XXLIST__			__L2LIST__

#define ____XXLIST__			__XXLIST__

#if ____XXLIST__ == __DFLIST__
# define l2name				"df"
#elif __XXLIST__ == __L2LIST__
# define l2name				"l2"
#endif				/* ____XXLIST__ == __DFLIST__ */

#if ____XXLIST__ == __DFLIST__
# define __HEAD_NEXT_LIST__		0
#elif __XXLIST__ == __L2LIST__
# define __HEAD_NEXT_LIST__		1
#endif				/* ____XXLIST__ == __DFLIST__ */

#if ____XXLIST__ == __DFLIST__
# define __HEAD_REEL_LIST__		0
#elif __XXLIST__ == __L2LIST__
# define __HEAD_REEL_LIST__		1
#endif				/* ____XXLIST__ == __DFLIST__ */

#if ____XXLIST__ == __DFLIST__
# define x1f4_ever_l2list		x1f4_ever_dflist
# define x1f4_fini_l2list		x1f4_fini_dflist
# define x1f4_flip_l2list		x1f4_flip_dflist
# define x1f4_head_l2list		x1f4_head_dflist
# define x1f4_high_l2list		x1f4_high_dflist
# define x1f4_init_l2list		x1f4_init_dflist
# define x1f4_last_l2list		x1f4_last_dflist
# define x1f4_lead_l2list		x1f4_lead_dflist
# define x1f4_lime_l2list		x1f4_lime_dflist
# define x1f4_mind_l2list		x1f4_mind_dflist
# define x1f4_next_l2list		x1f4_next_dflist
# define x1f4_reel_l2list		x1f4_reel_dflist
# define x1f4_roll_l2list		x1f4_roll_dflist
# define x1f4_tail_l2list		x1f4_tail_dflist
# define x1f4_size_l2list		x1f4_size_dflist
# define x1f4_slip_l2list		x1f4_slip_dflist
#elif __XXLIST__ == __L2LIST__
#endif				/* ____XXLIST__ == __DFLIST__ */

#endif				/* __LIBx1f4l2_L2XX_H__ */
